// === button_actions.cpp ===
#include "button_actions.h"
#include "globals.h"
#include "debugger.h"
#include "led_colors.h"

void ButtonAction_ToggleMode()
{
    if (globals.systemStatus == sysStat_Normal)
    {
        globals.systemStatus = sysStat_Rain;
        globals.resumeStatus = sysStat_Rain;
    }
    else if (globals.systemStatus == sysStat_Rain)
    {
        globals.systemStatus = sysStat_Normal;
        globals.resumeStatus = sysStat_Normal;
    }
    Debug_pushMessage("Toggling Mode\n");
}

void ButtonAction_StartPurge()
{
    globals.systemStatus = sysStat_Purge;
    globals.purgePulses = LubeConfig.BleedingPulses;
    Debug_pushMessage("Starting Purge\n");
}

void ButtonAction_ToggleWiFi()
{
    extern void toggleWiFiAP(bool shutdown = false);
    toggleWiFiAP();
    Debug_pushMessage("Toggling WiFi\n");
}

void ButtonAction_WashMode()
{
    Debug_pushMessage("Wash mode not yet implemented\n");
    // TODO: Implementieren, sobald Verhalten klar ist
}

// Liste der Aktionen, sortiert nach Mindest-Haltezeit (ms)
const ButtonActionEntry buttonActions[] = {
    {500, LED_RAIN_COLOR, ButtonAction_ToggleMode},
    {3500, LED_PURGE_COLOR, ButtonAction_StartPurge},
    {6500, LED_WIFI_BLINK, ButtonAction_ToggleWiFi},
    {9500, COLOR_WARM_WHITE, ButtonAction_WashMode}};

const uint8_t buttonActionCount = sizeof(buttonActions) / sizeof(ButtonActionEntry);
